# CSS Code Style


## Table of Contents

* [Introduction](introduction#introduction)
    * [Tools & Frameworks](introduction#tools--frameworks)
    * [Philosophy & Structure](introduction#philosophy--structure)
* [CSS Best Practices](css-best-practices#css-best-practices)
    * [Code Like it's 2020](css-best-practices#code-like-its-2020)
    * [Selector Specificity](css-best-practices#selector-specificity)
    * [A Note On Attribute Selectors](css-best-practices#a-note-on-attribute-selectors)
    * [Class Naming Convention](css-best-practices#class-naming-convention)
    * [Self Documenting Selectors](css-best-practices#self-documenting-selectors)
    * [Single Direction Rule](css-best-practices#single-direction-rule)
    * [Name Spacing](css-best-practices#name-spacing)
    * [Size Units](css-best-practices#size-units)
    * [Context Sensitivity](css-best-practices#context-sensitivity)
    * [Format](css-best-practices#format)
    * [Declaration Order](css-best-practices#declaration-order)
* [Sass (SCSS) Best Practices](sass-best-practices#sass-scss-best-practices)
    * [Nest Only When Necessary](sass-best-practices#nest-only-when-necessary)
    * [Global vs. Local Variables/Mixins](sass-best-practices#global-vs-local-variablesmixins)
    * [`@extends`](sass-best-practices#extends)
    * [Filename Naming Convention](sass-best-practices#filename-naming-convention)
    * [Note on Partials](sass-best-practices#note-on-partials)
    * [Commenting Best Practice](sass-best-practices#commenting-best-practice)
    * [Variable Naming Convention](sass-best-practices#variable-naming-convention)
* [Class Naming Conventions](class-naming-conventions#class-naming-conventions)
    * [Basic Conventions](class-naming-conventions#basic-conventions)
    * [CSM](class-naming-conventions#csm)
        * [Components](class-naming-conventions#components)
        * [Sub-Components](class-naming-conventions#sub-components)
        * [Modifiers](class-naming-conventions#modifiers)
        * [Component modifiers that affect subcomponents](class-naming-conventions#component-modifiers-that-affect-subcomponents)
        * [State](class-naming-conventions#state)
    * [Class Prefix Conventions](class-naming-conventions#class-prefix-conventions)
    * [Us versus Them](class-naming-conventions#us-versus-them-aka-theres-an-x-ception-to-every-rule)
        * [When to use our selector naming scheme](class-naming-conventions#when-to-use-our-selector-naming-scheme)
        * [When to use their existing selectors](class-naming-conventions#when-to-use-their-existing-selectors)
        * [How to use their existing selectors in our components](class-naming-conventions#how-to-use-their-existing-selectors-in-our-components)
* [Localization and Theming Best Practices](localization-and-theming-best-practices/readme.md)
* [Block Comment Documentation Guide](comments/Readme.md)
* [Hybrid Projects Best Practices](hybrid-projects/Readme.md)
* [Sass-Lint](sass-lint/readme.md)
    * [Using Sass-Lint with Atom](sass-lint/readme.md#using-sass-lint-with-atom)
    * [Using Sass-Lint with Sublime Text](sass-lint/readme.md#using-sass-lint-with-sublime-text)
* [CSSComb](csscomb/readme.md)
    * [Using CSSComb with Atom](csscomb/readme.md#atom)
    * [Using CSSComb with Sublime Text](csscomb/readme.md#sublime-text)

Continue on to [the Introduction →](introduction#introduction)
